<mat-form-field>
  <mat-label *ngIf="config.label">{{ config.label }}</mat-label>
  <mat-select
    [aria-label]="config.ariaLabel"
    [aria-labelledby]="config.ariaLabelledby"
    [compareWith]="config.compareWith || compareWith"
    [disableOptionCentering]="config.disableOptionCentering || false"
    [disableRipple]="config.disableRipple || false"
    [disabled]="config.disabled || false"
    [errorStateMatcher]="config.errorStateMatcher"
    [id]="config.id"
    [multiple]="config.multiple || false"
    [panelClass]="config.panelClass"
    [placeholder]="config.placeholder"
    [required]="config.required || false"
    [sortComparator]="config.sortComparator"
    [typeaheadDebounceInterval]="config.typeaheadDebounceInterval"
    [value]="config.value"
    (openedChange)="config.openedChange"
    (selectionChange)="config.selectionChange"
  >
    <ng-container *ngIf="data.length === 1 && data[0].label === undefined; else optionsGroup">
      <mat-option
        [value]="config.displayFn(option)"
        *ngFor="let option of data[0].items"
      >
        {{ config.displayFn(option) }}
      </mat-option>
    </ng-container>
    <ng-template #optionsGroup>
      <mat-optgroup
        [label]="group.label"
        *ngFor="let group of data">
      <mat-option
        [value]="config.displayFn(option)"
        *ngFor="let option of group.items"
      >
        {{ config.displayFn(option) }}
      </mat-option>
      </mat-optgroup>
    </ng-template>
  </mat-select>
</mat-form-field>
